// Description: A working ArmA dialog with sample usage of most controls
// By: Dr Eyeball
// Version: 1.1 (May 2007)
//-----------------------------------------------------------------------------
// Constants
//-----------------------------------------------------------------------------
// The following IDD & IDC variables should match their equivalents for the dialog (from "Dialogs\MyTestDialog.hpp")
LOC3_IDD_MyTestDialog = 390;

LOC3_IDC_ListBox = 891;
LOC3_IDC_HTML = 892;
LOC3_IDC_Picture = 893;
LOC3_IDC_Text = 894;
LOC3_IDC_Map = 895;
LOC3_IDC_OkButton = 896;
LOC3_IDC_CloseButton = 897;
LOC3_IDC_Combo = 898;
LOC3_IDC_DisabledButton = 899;
LOC3_IDC_StructuredText = 900;

//-----------------------------------------------------------------------------
// Functions
//-----------------------------------------------------------------------------
LOC3_OnClose = 
{
  //
};
//-----------------------------------------------------------------------------
LOC3_Select =
{
  _selection = _this select 0;  
  
  _control = _selection select 0;
  _selectedIndex = _selection select 1; 

  // get html file name
  _HTMLFile = "";
  _imageFile = "";
  _bonus = 0;
  _objPos = getmarkerpos "m_Start";
  _basePos = getmarkerpos "m_Start";
  
  _array =
  [// _HTMLFile, _bonus, _objPosMarkerName, _imageFile
    ["Sample_1", 10, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 10, "m_Target", "menu_tutorial_ca.paa"],
    ["Sample_1", 10, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 10, "m_Target", "menu_tutorial_ca.paa"],
    ["Sample_1", 10, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 10, "m_Target", "menu_tutorial_ca.paa"],
    
    ["Sample_1", 20, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_tutorial_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_tutorial_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_tutorial_ca.paa"],
    
    ["Sample_1", 20, "m_Target", "menu_options_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_tutorial_ca.paa"],
    ["Sample_1", 20, "m_Target", "menu_options_ca.paa"]
  ];
  
  _i = 0;
  {
    if (_i == _selectedIndex) then
    {
      _HTMLFile = _x select 0;
      _bonus = _x select 1;
      _objPos = getmarkerpos (_x select 2);
      _imageFile = _x select 3;    
    };
    _i = _i + 1;
  } forEach _array;

  /* TODO: Fix. It doesn't find "LANGUAGE" entry.
  _language = localize "LANGUAGE";
  if (_language == "") then { hint "LANGUAGE not found"; _language = "English" };
  */
  _language = "English";
  
  // show html
  _PathName = format["Dialogs\HTML\%1\%2.html", _language, _HTMLFile];
  _control = LOC3_display displayCtrl LOC3_IDC_HTML;
  _control htmlLoad _PathName;
  
  // show image
  //_PathName = format["Images\%1", _imageFile];
  _PathName = format["\CA\ui\data\%1", _imageFile];  
  ctrlSetText [LOC3_IDC_Picture, _PathName ];
  
  // show bonus points
  //ctrlSetText [LOC3_IDC_Text, format["Points: %1", _bonus ] ];
  
  //---- show map location using panning & zooming
  [LOC3_display, LOC3_IDC_Map, _basePos, _objPos] call Dlg_PanMapBetweenTwoPositions;
};
//----------------------
LOC3_OkButton =
{
  _selectedIndex = lbCurSel LOC3_IDC_ListBox;
  
  player globalChat format["Item selected: %1 '%2'", 
    _selectedIndex, 
    lbData [LOC3_IDC_ListBox, _selectedIndex] ];
};
//----------------------
LOC3_Start =
{
  _Params = _this;
  
  //LOC3_display displaySetEventHandler["KeyDown", _closeDialog]; // uncomment to enable close on key press
  LOC3_display displaySetEventHandler["Unload", "call LOC3_OnClose"];
  //---------------------
  _MyDualList =
  [
    ["Item 1", "Item Data 1"],
    ["Item 2", "Item Data 2"],
    ["Item 3", "Item Data 3"],
    ["Item 4", "Item Data 4"],
    ["Item 5", "Item Data 5"],
    ["Item 6", "Item Data 6"],
    ["Item 11", "Item Data 11"],
    ["Item 12", "Item Data 12"],
    ["Item 13", "Item Data 13"],
    ["Item 14", "Item Data 14"],
    ["Item 15", "Item Data 15"],
    ["Item 16", "Item Data 16"],
    ["Item 21", "Item Data 21"],
    ["Item 22", "Item Data 22"],
    ["Item 23", "Item Data 23"]
  ];

  [LOC3_IDC_ListBox, _MyDualList] call Dlg_FillListBoxLists;
  [LOC3_IDC_Combo, _MyDualList] call Dlg_FillListBoxLists;
  
  // highlight some rows
  lbSetColor [LOC3_IDC_ListBox, 2, [0, 1, 0, 0.9]]; 
  lbSetColor [LOC3_IDC_ListBox, 3, [1, 0.3, 0, 0.9]];
  //---------------------
  _ctrl = LOC3_display displayCtrl LOC3_IDC_StructuredText;
  _ctrl ctrlSetStructuredText parseText "Structured Text control. The <t color='#f000ff00'>helicopter</t> is now over <br/>the <t size='1.5'>landing zone</t>. Do you want to eject from the <t color='#ff0000ff'>helicopter</t>? The quick brown fox jumps over the lazy dog.";;
  //---------------------
  ctrlEnable [LOC3_IDC_DisabledButton, false];
};
//-----------------------------------------------------------------------------
// Init
//-----------------------------------------------------------------------------

_ok = createDialog "LOC3_MyTestDialog";
if !(_ok) exitWith { hint "createDialog failed" };

LOC3_display = findDisplay LOC3_IDD_MyTestDialog; 

_Params = _this;
_Params call LOC3_Start;
